VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "NemoX engine Cartoon Rendering Demo"
   ClientHeight    =   5430
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6750
   LinkTopic       =   "Form1"
   ScaleHeight     =   5430
   ScaleWidth      =   6750
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'============================================================
'
'This little demo shows how to render models with cartoon style
'by using the nemoX vertex shader tool library
'
'
'
'
'
'===========================================================





'the main engine
Dim Nemo As NemoX


'the Xmesh model
Dim Xmesh As cNemo_XFile


'the shader tool
Dim Shader As cNemo_ShaderPool


'cartoon Shading Parameters

'light
Dim Light As D3DVECTOR
Dim LineSize As Long



Public IsActive As Boolean


Function Vec(a, b, c) As D3DVECTOR
   Vec.x = a
   Vec.y = b
   Vec.z = c
End Function

Sub Init_All()
   
   'create the engine
   Set Nemo = New NemoX
   Set Xmesh = New cNemo_XFile
   
   'If Nemo.Initialize(hWnd) = False Then
      'MsgBox "Could not create Nemo Main Renderer"
   'End If
   Nemo.INIT_ShowDeviceDLG Me.hWnd
   
   'set some parameters
   Nemo.Set_ViewFrustum 1, 5000, 3.14 / 8
   Nemo.Set_EngineTextureFilter NEMO_FILTER_BILINEAR
   
   Nemo.Set_light True
   Nemo.BackBuffer_ClearCOLOR = RGB(125, 15, 54)
   'set camera
   Nemo.Camera_SetPosition Vec(0#, 8#, 10#), _
                                Vec(0#, 8#, 11#)
   
   
'it's important to create sharder after main NemoDevice was Created first
Set Shader = New cNemo_ShaderPool
'change shaders parameters
    Light.x = -1
    Light.y = 0.01
    Light.z = -0.8
    
    LineSize = 165


  'load a model change models
  Xmesh.LoadXmesh App.Path + "\Xmodels\worlf.x"
  Xmesh.Set_Texture App.Path + "\Xmodels\shade.jpg"
  Xmesh.Set_Scale 1, 1, 1
  Xmesh.Set_Position 0, 0, 150
  
  

   Me.IsActive = True
End Sub


Private Sub Form_Load()
   '
   Me.Show
   Me.Refresh
   Call Me.Init_All
   Call TheLoop
End Sub




Sub TheLoop()
  
 Dim I
Do
  If Nemo.GetD3dDevice Is Nothing Then Exit Do
  GetKey
  Nemo.Begin3D '============> begin 3d rendering
  
      Nemo.CalculateFrustum  'don't forget to update visibilty
      
        
       'rotate object
       Xmesh.Set_Rotation 0, Cos(Timer), Sin(Timer)
       
      'save renderstate
      Nemo.Push_AllRenderstate
        
      'set body cartoon
      Shader.Send_CartoonBody Xmesh.GetObjectWorldMatrix, Light, 0.5, 0.4, 0.4, 0.4
      Xmesh.RenderWithLastShader
      
      
      'set the silhouetter parameters here
       Shader.Send_CartoonSiluhette D3DCMP_LESS, LineSize
       Xmesh.RenderWithLastShader
    
      
      
       'restore renderstate
       Nemo.Pop_AllRenderstate
       
      'the fps counter
      Nemo.Draw_Text Str(Nemo.Framesperseconde), 1, 1
  
  Nemo.End3D   '===========> end 3d rendering scene
  DoEvents
Loop Until Nemo.Get_KeyPress(NEMO_KEY_ESCAPE)
 

TheEnd:

Call EndIt


End Sub



Sub GetKey()



If Nemo.Get_KeyPress(NEMO_KEY_LEFT) Then _
    Nemo.Camera_Turn_Left 1.5 / 50
If Nemo.Get_KeyPress(NEMO_KEY_RIGHT) Then _
    Nemo.Camera_Turn_Right 1.5 / 50
    
    
    If Nemo.Get_KeyPress(NEMO_KEY_UP) Then _
    Nemo.Camera_Move_Foward 4
    If Nemo.Get_KeyPress(NEMO_KEY_RCONTROL) Then _
    Nemo.Camera_Move_Foward 10
   If Nemo.Get_KeyPress(NEMO_KEY_DOWN) Then _
    Nemo.Camera_Move_Backward 4



  If Nemo.Get_KeyPress(NEMO_KEY_ADD) Then _
    Nemo.Camera_Strafe_UP 1
If Nemo.Get_KeyPress(NEMO_KEY_SUBTRACT) Then _
    Nemo.Camera_Strafe_DOWN 1


 If Nemo.Get_KeyPress(NEMO_KEY_NUMPAD8) Then
    Nemo.Camera_Turn_UP 1 / 50
End If
If Nemo.Get_KeyPress(NEMO_KEY_NUMPAD2) Then _
    Nemo.Camera_Turn_DOWN 1 / 50
    
If Nemo.Get_KeyPress(NEMO_KEY_SPACE) Then _
 Nemo.Camera_SetPosition Vector(0#, 8#, -8#), _
                                Vector(0#, 8#, 500#)

If Nemo.Get_KeyPress(NEMO_KEY_S) Then _
 Nemo.Take_SnapShot App.Path + "\Shot.bmp"




End Sub


Sub EndIt()
  
  'free resource
  If IS_active Then _
  Nemo.Free
  End
End Sub

Private Sub Form_Unload(Cancel As Integer)
  EndIt
End Sub
